// Copyright 2021 Matrix Origin
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package order

import (
	"matrixone/pkg/container/types"
	"matrixone/pkg/sql/op"
)

// Direction for ordering results.
type Direction int8

// Direction values.
const (
	DefaultDirection Direction = iota
	Ascending
	Descending
)

type Attribute struct {
	Name string
	Type types.T
	Dirt Direction
}

type Order struct {
	Prev       op.OP
	IsPD       bool        // can be push down?
	ID         string      // 关系变量的名称
	Attributes []Attribute // 操作的列
}
