// Copyright 2021 Matrix Origin
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package config

import (
	cConfig "github.com/matrixorigin/matrixcube/config"
	"github.com/matrixorigin/matrixcube/server"
)

type Config struct {
	CubeConfig    cConfig.Config //config of cubeDriver
	ServerConfig  server.Cfg     //config of the server
	ClusterConfig ClusterConfig  //config of the cluster
}

type ClusterConfig struct {
	PreAllocatedGroupNum uint64 `toml:"pre-allocated-group-num"` //the number of shards allocated in initiation
	MaxGroupNum          uint64 `toml:"max-group-num"`           //the max number of shards
}
